Ruby trunk - Bug #4937

trunk@32244 MinGW build failure - thread_win32.c
06/27/2011 11:58 PM - jonforums (Jon Forums)

Status: Closed

Priority: Normal

Assignee: ko1 (Koichi Sasada)

Target version: 1.9.3

ruby -v: ruby 1.9.3dev (2011-06-27 trunk 32242) |Backport:
[(386-mingw32]

Description
The signature of native_stop_timer_thread at

https://github.com/ruby/ruby/blob/trunk/thread_win32.c#L748

conflicts with it's usage by rb_thread_stop_timer_thread at
https://github.com/ruby/ruby/blob/trunk/thread.c#L2989

resulting in the following build error when using the Rubylnstaller build recipes and gcc.exe (tdm-1) 4.5.2:

compiling ../../../../Users/Jon/Documents/RubyDev/ruby-git/thread.c

om
/..1..1../Users/Jon/Documents/RubyDev/ruby-git/thread.c: In function 'rb_thread_stop_timer_thread':
/..1..]../Users/Jon/Documents/RubyDev/ruby-git/thread.c:2989:5: error: too many arguments to function 'native_stop_timer_thread'
/..1..]../Users/Jon/Documents/RubyDev/ruby-git/thread_win32.c:748:1: note: declared here

History

#1 - 06/28/2011 09:49 AM - luislavena (Luis Lavena)
- Category set to build

- Assignee set to ko1 (Koichi Sasada)

This was introduced in r32244 by Koichi Sasada. Assigning it to him.

Sasada-san, seems the signature change in thread_win32.c is missing, the following patch solves the compilation but I'm unsure the extend of the
needed changes:

diff --git a/thread_win32.c b/thread_win32.c

index 5¢20650..68fb346 100644

--- a/thread_win32.c

+++ b/thread_win32.c

@@ -745,7 +745,7 @@ rb_thread_create_timer_thread(void)
1

static int
-native_stop_timer_thread(void)
+native_stop_timer_thread(int close_anyway)

{
int stopped = --system_working <= 0;
if (stopped) {

#2 - 06/28/2011 09:51 AM - nahi (Hiroshi Nakamura)

- Target version set to 1.9.3

#3 - 06/29/2011 12:23 AM - jonforums (Jon Forums)
fixed by trunk@32268 with make test and make test-all TESTS='openssl fiddle psych' all passing

#4 - 06/29/2011 01:08 PM - usa (Usaku NAKAMURA)
- Status changed from Open to Closed
